<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTextMessageInbox_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTextMessageInbox_V3 extends AbstractStructArrayBase
{
    /**
     * The TextMessageInbox_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TextMessageInbox_V3[]
     */
    public $TextMessageInbox_V3;
    /**
     * Constructor method for ArrayOfTextMessageInbox_V3
     * @uses ArrayOfTextMessageInbox_V3::setTextMessageInbox_V3()
     * @param \StructType\TextMessageInbox_V3[] $textMessageInbox_V3
     */
    public function __construct(array $textMessageInbox_V3 = array())
    {
        $this
            ->setTextMessageInbox_V3($textMessageInbox_V3);
    }
    /**
     * Get TextMessageInbox_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TextMessageInbox_V3[]|null
     */
    public function getTextMessageInbox_V3()
    {
        return isset($this->TextMessageInbox_V3) ? $this->TextMessageInbox_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTextMessageInbox_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTextMessageInbox_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTextMessageInbox_V3ForArrayConstraintsFromSetTextMessageInbox_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTextMessageInbox_V3TextMessageInbox_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfTextMessageInbox_V3TextMessageInbox_V3Item instanceof \StructType\TextMessageInbox_V3) {
                $invalidValues[] = is_object($arrayOfTextMessageInbox_V3TextMessageInbox_V3Item) ? get_class($arrayOfTextMessageInbox_V3TextMessageInbox_V3Item) : sprintf('%s(%s)', gettype($arrayOfTextMessageInbox_V3TextMessageInbox_V3Item), var_export($arrayOfTextMessageInbox_V3TextMessageInbox_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TextMessageInbox_V3 property can only contain items of type \StructType\TextMessageInbox_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TextMessageInbox_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageInbox_V3[] $textMessageInbox_V3
     * @return \ArrayType\ArrayOfTextMessageInbox_V3
     */
    public function setTextMessageInbox_V3(array $textMessageInbox_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($textMessageInbox_V3ArrayErrorMessage = self::validateTextMessageInbox_V3ForArrayConstraintsFromSetTextMessageInbox_V3($textMessageInbox_V3))) {
            throw new \InvalidArgumentException($textMessageInbox_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($textMessageInbox_V3) || (is_array($textMessageInbox_V3) && empty($textMessageInbox_V3))) {
            unset($this->TextMessageInbox_V3);
        } else {
            $this->TextMessageInbox_V3 = $textMessageInbox_V3;
        }
        return $this;
    }
    /**
     * Add item to TextMessageInbox_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageInbox_V3 $item
     * @return \ArrayType\ArrayOfTextMessageInbox_V3
     */
    public function addToTextMessageInbox_V3(\StructType\TextMessageInbox_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TextMessageInbox_V3) {
            throw new \InvalidArgumentException(sprintf('The TextMessageInbox_V3 property can only contain items of type \StructType\TextMessageInbox_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TextMessageInbox_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TextMessageInbox_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TextMessageInbox_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TextMessageInbox_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TextMessageInbox_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TextMessageInbox_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TextMessageInbox_V3
     */
    public function getAttributeName()
    {
        return 'TextMessageInbox_V3';
    }
}
